<?php

/*------------------------------------------------------------------------
# com_joomd - JoomD
# ------------------------------------------------------------------------
# author    Danish Babu - Joomla6Teen Inc
# copyright Copyright (C) 2011 joomla6teen.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.joomla6teen.com
# Technical Support:  Forum - http://www.joomla6teen.com/index.php?option=com_ccboard&view=forumlist&Itemid=63
-----------------------------------------------------------------------*/

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );


class JoomdControllerField extends JoomdController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();
		
		// Register Extra tasks
		$this->registerTask( 'rcore', 'dcore' );
		$this->registerTask( 'add',	'edit' );
		$this->registerTask( 'apply', 'save' );
		$this->registerTask( 'unpublish', 'publish' );
		$this->registerTask( 'accesspublic', 'access' );
		$this->registerTask( 'accessregistered', 'access' );
		$this->registerTask( 'accessspecial', 'access' );
		
		require_once(JPATH_SITE.'/components/com_joomd/libraries/classes/fields.php');
		
		$this->_field = new JoomdFields();

	}
	
	function dcore()
	{
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( JText::_('INVALIDTOKEN') );
		
		$array = JRequest::getVar('cid',  0, '', 'array');
		$id = (int)$array[0];
		
		if($this->getTask()=='dcore')	{
			$msg = JText::_('ADDTOCFIELD');
			$func = 'makecore';
		}
		else	{
			$msg = JText::_('REVFCF');
			$func = 'removecore';
		}
		
		if($this->_field->$func($id))	{
			
			$data = $this->getItems();
			
			$json->result = "success";
			$json->msg = $msg;
			$json->error = $this->_field->getError();
			$json->html = $data->html;
			
		}
		else	{
		
			$json->result = "error";
			$json->msg = '';
			$json->error = $this->_field->getError();
		
		}
		
		echo json_encode($json);
		
	}

	/**
	 * display the edit form
	 * @return void
	 */
	function edit()
	{
		
		JRequest::setVar( 'layout', 'form'  );
		
		$html = parent::edit();
		
		echo $html;
		
	}
	
	function save()
	{
		$model = $this->getModel('field');
		
		$obj = $model->store();
		
		echo json_encode($obj);
		
	}

	/**
	 * remove record(s)
	 * @return void
	 */
	function delete()
	{	
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( JText::_('INVALIDTOKEN') );
		
		$cid = JRequest::getVar('cid',  0, '', 'array');
				
		if($this->_field->delete($cid))	{
						
			$msg = JText::_('FIELDREVSUCC');
			
			$data = $this->getItems();
			
			$json->result = "success";
			$json->msg = $msg;
			$json->error = $this->_field->getError();
			$json->html = $data->html;
			$json->count = $data->count;
			$json->total = $data->total;
			
		}
		else	{
			$json->result = "error";
			$json->msg = '';
			$json->error = $this->_field->getError();
			
		}
		
		echo json_encode($json);

	}
	
	function publish()
	{
		$model = $this->getModel('field');
		$task = $this->getTask();
		
		if($model->publish())	{
			
			$data = $this->getItems();
			
			$msg = ($task=="publish")?JText::sprintf('PUBLISHSUCCESS', JText::_('FIELD')):JText::sprintf('UNPUBLISHSUCCESS', JText::_('FIELD'));
			
			$json->result = "success";
			$json->msg = $msg;
			$json->error = $model->getError();
			$json->html = $data->html;
			$json->count = $data->count;
			$json->total = $data->total;
			
		}
		else	{
		
			$json->result = "error";
			$json->msg = '';
			$json->error = $model->getError();
		
		}
		
		echo json_encode($json);
		
	}
	
	function reorder()
	{
	
		$model = $this->getModel('field');
		
		if($model->reorder())	{
			
			$data = $this->getItems();
			
			$msg = JText::_('FIELDSREORSUCC');
			
			$json->result = "success";
			$json->msg = $msg;
			$json->error = $model->getError();
			$json->html = $data->html;
			$json->count = $data->count;
			$json->total = $data->total;
			
		}
		else	{
		
			$json->result = "error";
			$json->msg = '';
			$json->error = $model->getError();
		
		}
		
		echo json_encode($json);
	
	}
	
	function saveorder()
	{
	
		$model = $this->getModel('field');
		
		if($model->saveorder())	{
			
			$data = $this->getItems();
			
			$json->result = "success";
			$json->msg = JText::_('FIELDSREORSUCC');
			$json->error = $model->getError();
			$json->html = $data->html;
			$json->count = $data->count;
			$json->total = $data->total;
						
		}
		else	{
			
			$json->result = "error";
			$json->error = $model->getError();
			
		}
		
		echo json_encode($json);
	
	}
	
	//to change the access level
	function access()
	{
		
		$model = $this->getModel('field');
		
		if($model->access())	{
			
			$data = $this->getItems();
			
			$msg = JText::_('ACCESSUPDATESUCCESS');
			
			$json->result = "success";
			$json->msg = $msg;
			$json->error = $model->getError();
			
		}
		else	{
		
			$json->result = "error";
			$json->msg = '';
			$json->error = $model->getError();
		
		}
		
		echo json_encode($json);
		
	}
	
	function getItems()
	{
		
		$model = $this->getModel('field');
		
		$items = $model->getItems();
		$params = $model->getParams();
		
		ob_start();
		
		$ordering = ($params->filter_order == 'i.ordering');
		
		$disabled = $ordering?'':'disabled="disabled"';
		
		$k = 0;
		$i = $params->limitstart;
		for ($n=0; $n < count( $items ); $n++)
		{
			$row =& $items[$n];
			
			require(JPATH_COMPONENT.DS.'views'.DS.'field'.DS.'tmpl'.DS.'default_item.php');
			
			$k = 1 - $k;
			$i++;
			
		}
		
		$html = ob_get_contents();
		
		ob_end_clean();
		
		$data->html = $html;
		$data->count = count($items);
		$data->total = $params->total;
		
		return $data;
		
	}
	
	function loaditems()
	{
		
		$data = $this->getItems();
		
		$json->result = "success";
		$json->html = $data->html;
		$json->count = $data->count;
		$json->total = $data->total;
		
		echo json_encode($json);
	
	}
	
	function delete_icon()
	{
		
		$model = $this->getModel('field');
		
		if($model->delete_icon())	{
			$msg = JText::_('IMAGEDELETESUCCESS');
			echo '{"result":"success", "msg":"'.$msg.'"}';
		}
		else	{
			
			echo '{"result":"error", "error":"'.$model->getError().'"}';
			
		}
		
	}
	
	function reloadcats()
	{
		
		$model = $this->getModel('field');
		
		$cats = $model->getCats();
		
		$obj->list = '';
				
		for($i=0;$i<count($cats);$i++)	{
		
			$obj->list .= '<option value="'.$cats[$i]->id.'"';
			if($cats[$i]->selected)
				$obj->list .= ' selected="selected"';
			$obj->list .= '>'.$cats[$i]->treename.'</option>';
			
		}
		
		$obj->result = 'success';
		
		echo json_encode($obj);
		
	}
	
	function loadfieldoptions()
	{
		
		// Check for request forgeries
		JRequest::checkToken() or jexit('{"result":"error", "error":"'.JText::_('INVALIDTOKEN').'"}');
		
		$type = JRequest::getInt('type', 0);
		$id = JRequest::getInt('id', 0);
		
		if(!$type)
			jexit('{"result":"error", "error":"'.JText::_('PLEASESELFIELDT').'"}');
		
		$obj->html = $this->_field->loadfieldoptions($id, $type);
		
		$obj->result = 'success';
			
		echo json_encode($obj);
		
	}
	
}