<?php

/*------------------------------------------------------------------------
# com_joomd - JoomD
# ------------------------------------------------------------------------
# author    Danish Babu - Joomla6Teen Inc
# copyright Copyright (C) 2011 joomla6teen.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.joomla6teen.com
# Technical Support:  Forum - http://www.joomla6teen.com/index.php?option=com_ccboard&view=forumlist&Itemid=63
-----------------------------------------------------------------------*/


// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();
 
jimport( 'joomla.application.component.model' );
jimport( 'joomla.installer.installer' );
jimport('joomla.installer.helper');


class JoomdModelPlugin extends JModel
{
    
    var $_total = null;
	var $_pagination = null;
	var $_warnings = array();
	var $_return = null;
	var $_manifest = null;
	
	function __construct()
	{
		parent::__construct();
 
        $mainframe =& JFactory::getApplication();
		
		$context			= 'com_joomd.plugin.list.'; 
        // Get pagination request variables
        $this->_limit = JRequest::getInt('limit', $mainframe->getCfg('list_limit'));
		$this->_limitstart = JRequest::getInt('limitstart', 0 );
		
		// In case limit has been changed, adjust it
        $this->_limitstart = ($this->_limit != 0 ? (floor($this->_limitstart / $this->_limit) * $this->_limit) : 0);
		
		$this->_filter_state		= $mainframe->getUserStateFromRequest( $context.'filter_state',	'filter_state',	'',	'word' );
		
		$this->_filter_order     = $mainframe->getUserStateFromRequest( $context.'filter_order', 'filter_order', 'ordering', 'cmd' );
        $this->_filter_order_Dir = $mainframe->getUserStateFromRequest( $context.'filter_order_Dir', 'filter_order_Dir', 'asc', 'word' );
		
		$this->_filter_search			= $mainframe->getUserStateFromRequest( $context.'filter_search', 'filter_search', '',	'string' );
		$this->_filter_search			= JString::strtolower( $this->_filter_search );
		

		$array = JRequest::getVar('cid',  0, '', 'array');
		$this->setId((int)$array[0]);
	}
	
	function setWarning($msg)
	{
		
		array_push($this->_warnings, $msg);
		
	}
	
	function _buildQuery()
	{
		$query = 'select * from #__joomd_plugins ';

		return $query;
	}
	
	function setId($id)
	{
		// Set id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}
	
	function &getItem()
    {
		
		$row =& $this->getTable();
		
		$row->load($this->_id);
		
        return $row;
    }
	
	function &getItems()
    {
        if(empty($this->_data))	{
		
			$query = $this->_buildQuery();
			$filter = $this->_buildItemFilter();
			$query .= $filter;
			$orderby = $this->_buildItemOrderBy();
			$query .= $orderby;
			
			$this->_data = $this->_getList($query, $this->_limitstart, $this->_limit);
		
		}
		echo $this->_db->getErrorMsg();
        return $this->_data;
    }
	
	function getParams()
  	{
		$this->item->limit = $this->_limit;
		$this->item->limitstart = $this->_limitstart;
		$this->item->filter_search = $this->_filter_search;
		$this->item->filter_state = $this->_filter_state;
		$this->item->filter_order = $this->_filter_order;
		$this->item->filter_order_Dir = $this->_filter_order_Dir;
		
        // Load the plugin if it doesn't already exist
        if (empty($this->_total)) {
            $query = $this->_buildQuery();
			$filter = $this->_buildItemFilter();
			$query .= $filter;
			$orderby = $this->_buildItemOrderBy();
			$query .= $orderby;
            $this->item->total = (int) $this->_getListCount($query);    
        }
        return $this->item;
  	}
	
	function _buildItemFilter()
	{

        $where = array();
		
		$where[] = 'parent = 0';
		
		if ( $this->_filter_state == 'P' )
			$where[] = 'published = 1';
		
		else if ($this->_filter_state == 'U' )
			$where[] = 'published = 0';
		
		if($this->_filter_search)	{
			
			$where2 = array();
			
			$where2[] = 'id = '.$this->_db->Quote( $this->_db->getEscaped( $this->_filter_search, true ), false );
			
			$where2[] = 'LOWER( name ) LIKE '.$this->_db->Quote( '%'.$this->_db->getEscaped( $this->_filter_search, true ).'%', false );
			
			$where[] = count($where2)?'('.implode(' or ', $where2).')':'';
			
		}
		
		$filter = count($where) ? ' WHERE ' . implode(' AND ', $where) : '';
		 
        return $filter;
	}
	
	function _buildItemOrderBy()
	{
 
        $orderby = ' group by id ORDER BY '.$this->_filter_order.' '.$this->_filter_order_Dir;
 
        return $orderby;
	}
	
	function getOrder_list()
	{
		
		$query = 'select * from #__joomd_plugins order by name asc';
		$this->_db->setQuery( $query );
		$items = $this->_db->loadObjectList();
		echo $this->_db->getErrorMsg();
		return $items;
	
	}

	function store()
	{
    	
		// Check for request forgeries
		JRequest::checkToken() or jexit( JText::_('INVALIDTOKEN') );
		
		if(JRequest::getInt('id', 0))	{
			
			$obj = $this->update();
			
		}
		
		else	{
			
			$obj = $this->save();
		
		}
		
		
		return $obj;
		
	}
	
	function save()	{
	
		$post = JRequest::get('post');
		
		$obj->result = 'error';
		$file->error = '';
		
		$this->installer =& JInstaller::getInstance();
		$package = $this->_getPackageFromUpload('file');
		
		if (!$package) {
			$obj->error = $this->getError();
			$file->error = $obj->error;	
		}
		
		elseif (!$this->setupInstall($package['dir'])) {
			$obj->error = $this->getError();
			$file->error = $obj->error;
		}
		
		elseif(!$this->install())	{
			$obj->error = $this->getError();
			$file->error = $obj->error;
		}
		
		else	{
			
			if (!is_file($package['packagefile'])) {
				$config =& JFactory::getConfig();
				$package['packagefile'] = $config->getValue('config.tmp_path').DS.$package['packagefile'];
			}
			
			JInstallerHelper::cleanupInstall($package['packagefile'], $package['extractdir']);
			
			
			$obj->id = $this->_id;
			
			$obj->warnings = $this->_warnings;
			
			$obj->result = 'success';
			
			$obj->msg = JText::_('PLGSVSUCC');
			
		}
		
		$obj->warnings = $this->_warnings;
		
		$obj->file = array($file);
		
		if($obj->result == 'success')	{
		
		if($this->manifest->attributes('type') == 'joomdplugin')	{
		
		$this->item = $this->getItem();
		$this->order_list = $this->getOrder_list();
		
		ob_start();
		
		?>
        
        <tr>
    <td class="key"><?php echo JText::_('NAME'); ?>:</td>
    <td><input type="text" name="name" id="name" value="<?php echo $this->item->name; ?>" size="40" /></td>
  </tr>
  <tr>
    <td class="key"><?php echo JText::_('ORSERING'); ?>:</td>
    <td colspan="2">
	<?php
		
		echo '<select name="ordering" id="ordering">';
		
		for($i=0;$i<count($this->order_list);$i++)	{
		
			echo '<option value="'.$this->order_list[$i]->ordering.'"';
			if($this->item->ordering == $this->order_list[$i]->ordering)
				echo ' selected="selected" ';
			echo '>'.$this->order_list[$i]->ordering.'::'.$this->order_list[$i]->name.'</option>';
		
		}
		
		echo '</select>';

	?>
	</td>
  </tr>
  <tr>
    <td class="key"><?php echo JText::_('DESCRIP'); ?>:</td>
    <td><textarea name="descr" id="descr" rows="4" cols="40"><?php echo $this->item->descr; ?></textarea></td>
  </tr>
  
  <?php
  
  		$obj->html = ob_get_contents();
		
		ob_clean();
		
		}
		
		}
		
		return $obj;
		
	}
	
	function update()
	{
		
		$post = JRequest::get('post');
		
		$obj->result = 'error';
		
		if($post['name'] == "")
			$obj->error = JText::_('PLSENTPLGNM');
		
		else	{
			
			$row =& $this->getTable();
			
			$row->load($post['id']);
			
			$row->name		= $post['name'];
			$row->ordering	= $post['ordering'];
			$row->descr		= $post['descr'];
			
			// If there was an error with registration, set the message and display form
			if ( !$row->store() )
			{
				$obj->error = $row->getError();
			}
			else	{
				$obj->result = 'success';
				$obj->msg = JText::_('INFOSVSUCC');
				
			}
		
		}
		
		return $obj;
		
	}
	
	function delete()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$cid 			= JRequest::getVar( 'cid', array(), '', 'array' );

		JArrayHelper::toInteger( $cid );
		

		if (count( $cid ) < 1) {
			$this->setError( JText::_( 'SLEAPLGTD', true ) );
			return false;
		}
		
		$row =& $this->getTable();

		foreach ($cid as $id)
		{
			
			if(!$this->uninstall($id))	{
				
				return false;
				
			}

		}

		return true;
	}
	
	function publish()
	{
	
		JRequest::checkToken() or jexit( JText::_('INVALIDTOKEN') );
		
		$cid		= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$task		= JRequest::getCmd( 'task' );
		$publish	= ($task == 'publish');
		
		if(count($cid) < 1)	{
			$this->setError(JText::_('PLSSELALEAONERE'));
			return false;
		}
		
		$row =& $this->getTable();
		
		if (!$row->publish($cid, $publish))	{
			$this->setError($row->getError());
			return false;
		}
		
		return true;
	
	}
	
	/**
	 * Moves the order of a record
	 */
	function reorder()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( JText::_('INVALIDTOKEN') );
				
		$ordering = JRequest::getVar('ordering', array(0), 'post', 'array');
		
		if(count($ordering) < 1)	{
			$this->setError( JText::_('NOITMF') );
			return false;	
		}
		
		$items = $this->getItems();
		
		$row =& $this->getTable();
		
		for($i=0;$i<count($items);$i++)	{
			
			$order = substr($ordering[$i], 6);
			
			$row->load($items[$order]->id);				
			$row->ordering = $items[$i]->ordering;
			
			if(!$row->store())	{
				$this->setError($row->getError());
				return false;
			}
				
			
		}
		
		return true;
	}

	/**
	 * Saves the orders of the supplied list
	 */
	function saveorder()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( JText::_('INVALIDTOKEN') );


		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (empty( $cid )) {
			$this->setError( JText::_('NOSELECT') );
			return false;
		}

		$total		= count( $cid );
		$row =& $this->getTable();
		$groupings = array();

		$order 		= JRequest::getVar( 'ordering', array(0), 'post', 'array' );
		JArrayHelper::toInteger($order);

		// update ordering values
		for ($i = 0; $i < $total; $i++)
		{
			$row->load( (int) $cid[$i] );

			if ($row->ordering != $order[$i])
			{
				$row->ordering = $order[$i];
				if (!$row->store()) {
					$this->setError( $row->getError() );
					return false;
				}
			}
		}

		return true;
	}
	
	//package installation
	
	function install()
	{
		
		$this->manifest =& $this->_manifest->document;
		
		if($this->manifest->attributes('type') == 'joomdplugin')	{
			
			return $this->installplugin();
		}
		
		elseif($this->manifest->attributes('type') == 'joomdlanguage')	{
			
			return $this->installlang();
			
		}
		else	{
			$this->setError(JText::_('PLGCNREC'));
			return false;
		}
		
	}
	
	function installplugin()
	{
		
		/**
		 * ---------------------------------------------------------------------------------------------
		 * Manifest Document Setup Section
		 * ---------------------------------------------------------------------------------------------
		 */

		// Set the extensions name
		$name =& $this->manifest->getElementByPath('name');
		$name = JFilterInput::clean($name->data(), 'cmd');
		$name = strtolower(str_replace(' ', '', $name));		
		
		$this->installer->set('name', $name);
		
		
		// Get the component description
		$description = & $this->manifest->getElementByPath('description');
		if (is_a($description, 'JSimpleXMLElement')) {
			$this->installer->set('message', $description->data());
		} else {
			$this->installer->set('message', '' );
		}

		// Get some important manifest elements
		$this->adminElement		=& $this->manifest->getElementByPath('administration');
		$this->siteFiles		=& $this->manifest->getElementByPath('files');
		$this->adminFiles		=& $this->adminElement->getElementByPath('files');

		// Set the installation target paths
		$this->installer->setPath('extension_site', JPath::clean(JPATH_SITE.DS."components".DS.'com_joomd'));
		$this->installer->setPath('extension_administrator', JPath::clean(JPATH_ADMINISTRATOR.DS."components".DS.'com_joomd'));
		
		/**
		 * ---------------------------------------------------------------------------------------------
		 * Filesystem Processing Section
		 * ---------------------------------------------------------------------------------------------
		 */

		// Find files to copy
		foreach ($this->siteFiles->children() as $child)
		{
			if (is_a($child, 'JSimpleXMLElement') && $child->name() == 'views') {
				if ($this->parseViews($child) === false) {
					// Install failed, rollback any changes
					$this->installer->abort();
					return false;
				}
				$this->installer->pushStep(array ('type' => 'folder', 'path' => $this->installer->getPath('extension_site').DS.'views'.DS.$child->attributes('name')));
			}
			else	{
				if ($this->parseFiles($child) === false) {
					// Install failed, rollback any changes
					$this->installer->abort();
					return false;
				}				
			}
		}
		
		if ( is_a($this->adminElement, 'JSimpleXMLElement') )
		{

			foreach ($this->adminFiles->children() as $child)
			{
				if (is_a($child, 'JSimpleXMLElement') && $child->name() == 'views') {
					if ($this->parseViews($child, 1) === false) {
						// Install failed, rollback any changes
						$this->installer->abort();
						return false;
					}
					$this->installer->pushStep(array ('type' => 'folder', 'path' => $this->installer->getPath('extension_administrator').DS.'views'.DS.$child->attributes('name')));
				}
				else	{
					if ($this->parseFiles($child, 1) === false) {
						// Install failed, rollback any changes
						$this->installer->abort();
						return false;
					}				
				}
			}
		
		}
		
		
		// If there is an install file, lets copy it.
		$installScriptElement =& $this->manifest->getElementByPath('installfile');
		if (is_a($installScriptElement, 'JSimpleXMLElement')) {
			// check if it actually has a value
			$installScriptFilename = $installScriptElement->data();
			if(empty($installScriptFilename)) {
				if(JDEBUG) $this->setWarning(JText::sprintf('BLANKSCRIPTELEMENT', JText::_('INSTALL')));
			} else {
				// Make sure it hasn't already been copied (this would be an error in the xml install file)
				// Only copy over an existing file when upgrading components
				if (!file_exists($this->installer->getPath('extension_administrator').DS.'others'.DS.$installScriptFilename) || $this->installer->getOverwrite())
				{
					$path['src']	= $this->installer->getPath('source').DS.$installScriptFilename;
					$path['dest']	= $this->installer->getPath('extension_administrator').DS.'others'.DS.$installScriptFilename;
					if(file_exists($path['src']) && file_exists(dirname($path['dest']))) {
						if (!$this->copyFiles(array ($path))) {
							// Install failed, rollback changes
							$this->installer->abort();
							return false;
						}
					} else if(JDEBUG) {
						$this->setWarning(JText::sprintf('INVALIDINSTALLFILE', JText::_('INSTALL')));
					}
				}
				$this->installer->set('install.script', $installScriptFilename);
			}
		}

		// If there is an uninstall file, lets copy it.
		$uninstallScriptElement =& $this->manifest->getElementByPath('uninstallfile');
		if (is_a($uninstallScriptElement, 'JSimpleXMLElement')) {
			// check it actually has a value
			$uninstallScriptFilename = $uninstallScriptElement->data();
			if(empty($uninstallScriptFilename)) {
				// display a warning when we're in debug mode
				if(JDEBUG) $this->setWarning(JText::sprintf('BLANKSCRIPTELEMENT', JText::_('UNINSTALL')));
			} else {
				// Make sure it hasn't already been copied (this would be an error in the xml install file)
				// Only copy over an existing file when upgrading components
				if (!file_exists($this->installer->getPath('extension_administrator').DS.'others'.DS.$uninstallScriptFilename) || $this->parent->getOverwrite())
				{
					$path['src']	= $this->installer->getPath('source').DS.$uninstallScriptFilename;
					$path['dest']	= $this->installer->getPath('extension_administrator').DS.'others'.DS.$uninstallScriptFilename;
					if(file_exists($path['src']) && file_exists(dirname($path['dest']))) {
						if (!$this->copyFiles(array ($path))) {
							// Install failed, rollback changes
							$this->installer->abort();
							return false;
						}
					} else if(JDEBUG) {
						$this->setWarning(JText::sprintf('INVALIDINSTALLFILE', JText::_('UNINSTALL')));
					}
				}
			}
		}

		/**
		 * ---------------------------------------------------------------------------------------------
		 * Database Processing Section
		 * ---------------------------------------------------------------------------------------------
		 */

		/*
		 * Let's run the install queries for the component
		 *	If backward compatibility is required - run queries in xml file
		 *	If Joomla 1.5 compatible, with discreet sql files - execute appropriate
		 *	file for utf-8 support or non-utf-8 support
		 */
		$result = $this->parseQueries($this->manifest->getElementByPath('install/queries'));
		if ($result === false) {
			// Install failed, rollback changes
			$this->installer->abort();
			return false;
		} elseif ($result === 0) {
			// no backward compatibility queries found - try for Joomla 1.5 type queries
			// second argument is the utf compatible version attribute
			$utfresult = $this->parseSQLFiles($this->manifest->getElementByPath('install/sql'));
			if ($utfresult === false) {
				$this->setError(JText::_('CONTENT').' '.JText::_('INSTALL').': '.JText::_('SQLERRORORFILE')." ".$db->stderr(true));
				// Install failed, rollback changes
				$this->installer->abort();
				return false;
			}
		}
		
		/**
		 * ---------------------------------------------------------------------------------------------
		 * Custom Installation Script Section
		 * ---------------------------------------------------------------------------------------------
		 */

		/*
		 * If we have an install script, lets include it, execute the custom
		 * install method, and append the return value from the custom install
		 * method to the installation message.
		 */
		if ($this->installer->get('install.script')) {
			if (is_file($this->installer->getPath('extension_administrator').DS.'others'.DS.$this->installer->get('install.script'))) {
				ob_start();
				ob_implicit_flush(false);
				require_once ($this->installer->getPath('extension_administrator').DS.'others'.DS.$this->installer->get('install.script'));
				if (function_exists('com_install')) {
					if (com_install() === false) {
						$this->setError(JText::_('CUSTOMINSROUFAIL'));
						$this->installer->abort();
						return false;
					}
				}
				$msg = ob_get_contents();
				ob_end_clean();
				if ($msg != '') {
					$this->installer->set('extension.message', $msg);
				}
			}
		}

		/**
		 * ---------------------------------------------------------------------------------------------
		 * Finalization and Cleanup Section
		 * ---------------------------------------------------------------------------------------------
		 */

		// Lastly, we will copy the manifest file to its appropriate place.
		if (!$this->copyManifest()) {
			$this->setError(JText::_('COMPO').' '.JText::_('INSTALL').': '.JText::_('CNOTCSETF'));
			// Install failed, rollback changes
			$this->installer->abort();
			return false;
		}
		
		if(!$this->_buildMenus())	{
			$this->installer->abort();
			return false;
		}
		
		return true;
		
	}
	
	function installlang()
	{
		
		if($this->parseLanguages($this->manifest->getElementByPath('languages')) === false)
			return false;
		
		if($this->parseLanguages($this->manifest->getElementByPath('administration/languages'), 1) === false)
			return false;
			
		return true;
		
	}
	
	function _buildMenus()
	{
		
		$menuElement = & $this->adminElement->getElementByPath('menu');
		
		$name = $this->installer->get('name');
		$descr = $this->installer->get('message');
		$view = $this->installer->get('name');
		$icon = 0;
		$panel = 0;
		$img = '';
		$published = 1;
		$entry = 0;
		
		$ordering = 1;
		$query = 'select ordering from #__joomd_plugins order by ordering desc limit 1';
		$this->_db->setQuery( $query );
		$ordering += $this->_db->loadResult();
		
		if (is_a($menuElement, 'JSimpleXMLElement')) {
			
			$name = $menuElement->data();
			
			if($menuElement->attributes('view'))
				$view = $menuElement->attributes('view');
				
			if($menuElement->attributes('entry'))
				$view = $menuElement->attributes('entry');
				
			if($menuElement->attributes('icon'))
				$icon = $menuElement->attributes('icon');
				
			if($menuElement->attributes('panel'))
				$panel = $menuElement->attributes('panel');
				
			if($menuElement->attributes('img'))
				$img = $menuElement->attributes('img');
			
		}
		
		$query = 'insert into #__joomd_plugins (name, descr, view, entry, ordering, icon, panel, img, published) values ("'.$name.'", "'.$descr.'", "'.$view.'", '.(int)$entry.', '.(int)$ordering.', '.(int)$icon.', '.(int)$panel.', "'.$img.'", '.(int)$published.')';
		$this->_db->setQuery($query);
		
		if(!$this->_db->query())	{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		$this->_id = $this->_db->insertid();
		
		$submenu = & $this->adminElement->getElementByPath('submenu');
		
		if (is_a($submenu, 'JSimpleXMLElement') || count($submenu->children())) {
			$ordering = 0;
			
			foreach ($submenu->children() as $child)
			{
				if (is_a($child, 'JSimpleXMLElement') && $child->name() == 'menu') {
					
					$name = $child->data();
					$view = $child->attributes('view');
					$icon = ($child->attributes('icon'))?$child->attributes('icon'):0;
					$panel = ($child->attributes('panel'))?$child->attributes('panel'):0;
					$img = ($child->attributes('img'))?$child->attributes('img'):'';
					$descr = ($child->attributes('descr'))?$child->attributes('descr'):'';
					
					$query = 'insert into #__joomd_plugins (parent, name, descr, view, ordering, icon, panel, img, published) values ('.$this->_id.', "'.$name.'", "'.$descr.'", "'.$view.'", '.$ordering.', '.$icon.', '.$panel.', "'.$img.'", '.$published.')';
					$this->_db->setQuery($query);
					
					if(!$this->_db->query())	{
						$this->setError($this->_db->getErrorMsg());
						return false;
					}
				
					$ordering++;
				
				}
				
			}
			
		}
		
		return true;
		
	}
	
	//getting package from the upload
	
	function _getPackageFromUpload($filename)
	{
		// Get the uploaded file information
		$userfile = JRequest::getVar($filename, null, 'files', 'array' );

		// Make sure that file uploads are enabled in php
		if (!(bool) ini_get('file_uploads')) {
			$this->setError(JText::_('WARNINSTALLFILE'));
			return false;
		}

		// Make sure that zlib is loaded so that the package can be unpacked
		if (!extension_loaded('zlib')) {
			$this->setError(JText::_('WARNINSTALLZLIB'));
			return false;
		}

		// If there is no uploaded file, we have a problem...
		if (!is_array($userfile) ) {
			$this->setError(JText::_('NOFILESEL'));
			return false;
		}

		// Check if there was a problem uploading the file.
		if ( $userfile['error'] || $userfile['size'] < 1 )
		{
			$this->setError(JText::_('WARNINSTALLUPLOADERROR'));
			return false;
		}
		
		$ext = strrchr($userfile['name'], '.');
		
		if($ext <> ".zip")	{
			$this->setError(JText::_('ONLYZIPFALLO'));
			return false;
		}

		// Build the appropriate paths
		$config =& JFactory::getConfig();
		$tmp_dest 	= $config->getValue('config.tmp_path').DS.$userfile['name'];
		$tmp_src	= $userfile['tmp_name'];

		// Move uploaded file
		jimport('joomla.filesystem.file');
		$uploaded = JFile::upload($tmp_src, $tmp_dest);

		// Unpack the downloaded package file
		$package = $this->unpack($tmp_dest);

		return $package;
	}
	
	//set up install
	
	function setupInstall($source)
	{	
		
		// Get an array of all the xml files from teh installation directory
		$xmlfiles = JFolder::files($source, '.xml$', 1, true);
		// If at least one xml file exists
		if (!empty($xmlfiles)) {
			foreach ($xmlfiles as $file)
			{
				// Is it a valid joomla installation manifest file?
				$manifest = $this->_isManifest($file);
				if (!is_null($manifest)) {

					// If the root method attribute is set to upgrade, allow file overwrite
					$root =& $manifest->document;
					if ($root->attributes('method') == 'upgrade') {
						$this->installer->setOverwrite( true );
					}

					// Set the manifest object and path
					$this->_manifest =& $manifest;
					$this->installer->setPath('manifest', $file);

					// Set the installation source path to that of the manifest file
					$this->installer->setPath('source', dirname($file));

					return true;
				}
			}

			// None of the xml files found were valid install files
			$this->setError(JText::_('ERRORNOTFINDJOOMLAXMLSETUPFILE'));
			return false;
		} else {
			// No xml files were found in the install folder
			$this->setError(JText::_('ERRORXMLSETUP'));
			return false;
		}

		return true;
	}
	
	function uninstall($id)
	{
		// Initialize variables
		$retval	= true;

		// First order of business will be to load the component object table from the database.
		// This should give us the necessary information to proceed.
		$row = $this->getTable();
		
		if ( !$row->load((int) $id) || !trim($row->view) ) {
			$this->setError(JText::_('ERRORUNKOWNEXTENSION'));
			return false;
		}

		// Is the component we are trying to uninstall a core one?
		// Because that is not a good idea...
		if ($row->iscore) {
			$this->setError(JText::_('WARNCORECOMPONENT2'));
			return false;
		}
		
		$this->installer =& JInstaller::getInstance();
		
		// Get the admin and site paths for the component
		$this->installer->setPath('extension_administrator', JPath::clean(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_joomd'));
		$this->installer->setPath('extension_site', JPath::clean(JPATH_SITE.DS.'components'.DS.'com_joomd'));

		
		$this->installer->setPath('source', $this->installer->getPath('extension_administrator'));
		
		$query = 'select * from #__joomd_plugins where id = '.$row->id.' or parent = '.$row->id;
		$this->_db->setQuery( $query );
		$views = $this->_db->loadObjectList();
		
		/**
		 * ---------------------------------------------------------------------------------------------
		 * Manifest Document Setup Section
		 * ---------------------------------------------------------------------------------------------
		 */

		// Find and load the XML install file for the component
		$this->setUpInstall($this->installer->getPath('source').DS.'views'.DS.$row->view);
		
		$manifest = $this->_manifest;
		
		if (!is_a($manifest, 'JSimpleXML')) {
			
			foreach($views as $view)	{
			
				if(!empty($view->view))	{
			
					// Make sure we delete the folders if no manifest exists
					if(JFolder::exists($this->installer->getPath('extension_administrator').DS.'views'.DS.$view->view))
						JFolder::delete($this->installer->getPath('extension_administrator').DS.'views'.DS.$view->view);
					if(JFolder::exists($this->installer->getPath('extension_site').DS.'views'.DS.$view->view))
						JFolder::delete($this->installer->getPath('extension_site').DS.'views'.DS.$view->view);
						
					if(JFile::exists($this->installer->getPath('extension_administrator').DS.'controllers'.DS.$view->view.'.php'))
						JFile::delete($this->installer->getPath('extension_administrator').DS.'controllers'.DS.$view->view.'.php');
					if(JFile::exists($this->installer->getPath('extension_site').DS.'controllers'.DS.$view->view.'.php'))
						JFile::delete($this->installer->getPath('extension_site').DS.'controllers'.DS.$view->view.'.php');
						
					if(JFile::exists($this->installer->getPath('extension_administrator').DS.'models'.DS.$view->view.'.php'))
						JFile::delete($this->installer->getPath('extension_administrator').DS.'models'.DS.$view->view.'.php');
					if(JFile::exists($this->installer->getPath('extension_site').DS.'models'.DS.$view->view.'.php'))
						JFile::delete($this->installer->getPath('extension_site').DS.'models'.DS.$view->view.'.php');
					
				}

			}
			
			$this->removeMenus($views);
			
			$this->setError(JText::_('CNOTFSETTXMLSERFPCNBU'));

			// Return
			return false;
		}
		
		// Get the root node of the manifest document
		$this->manifest =& $manifest->document;
		
		// Get some important manifest elements
		$this->adminElement		=& $this->manifest->getElementByPath('administration');
		$this->siteFiles		=& $this->manifest->getElementByPath('files');
		$this->adminFiles		=& $this->adminElement->getElementByPath('files');		
		
		
		// Find files to copy
		foreach ($this->siteFiles->children() as $child)
		{
			if (is_a($child, 'JSimpleXMLElement') && $child->name() == 'views') {
				if(JFolder::exists($this->installer->getPath('extension_site').DS.'views'.DS.$child->attributes('name')))
					JFolder::delete($this->installer->getPath('extension_site').DS.'views'.DS.$child->attributes('name'));
					
				if(JFile::exists($this->installer->getPath('extension_site').DS.'controllers'.DS.$child->attributes('name').'.php'))
					JFile::delete($this->installer->getPath('extension_site').DS.'controllers'.DS.$child->attributes('name').'.php');
					
				if(JFile::exists($this->installer->getPath('extension_site').DS.'models'.DS.$child->attributes('name').'.php'))
					JFile::delete($this->installer->getPath('extension_site').DS.'models'.DS.$child->attributes('name').'.php');
			}
			else	{
				if ($this->removeFiles($child) === false) {
					$retval = false;
				}				
			}
		}
		
		/**
		 * ---------------------------------------------------------------------------------------------
		 * Database Processing Section
		 * ---------------------------------------------------------------------------------------------
		 */

		/*
		 * Let's run the uninstall queries for the component
		 *	If backward compatibility is required - run queries in xml file
		 *	If Joomla 1.5 compatible, with discreet sql files - execute appropriate
		 *	file for utf-8 support or non-utf support
		 */
		$result = $this->parseQueries($this->manifest->getElementByPath('uninstall/queries'));
		if ($result === false) {
			$retval = false;
		} elseif ($result === 0) {
			// no backward compatibility queries found - try for Joomla 1.5 type queries
			// second argument is the utf compatible version attribute
			$utfresult = $this->parseSQLFiles($this->manifest->getElementByPath('uninstall/sql'));
			if ($utfresult === false) {
				$retval = false;
			}
		}
		
		if ( is_a($this->adminElement, 'JSimpleXMLElement') )
		{

			foreach ($this->adminFiles->children() as $child)
			{
				if (is_a($child, 'JSimpleXMLElement') && $child->name() == 'views') {
					if(JFolder::exists($this->installer->getPath('extension_administrator').DS.'views'.DS.$child->attributes('name')))
						JFolder::delete($this->installer->getPath('extension_administrator').DS.'views'.DS.$child->attributes('name'));
						
					if(JFile::exists($this->installer->getPath('extension_administrator').DS.'controllers'.DS.$child->attributes('name').'.php'))
						JFile::delete($this->installer->getPath('extension_administrator').DS.'controllers'.DS.$child->attributes('name').'.php');
						
					if(JFile::exists($this->installer->getPath('extension_administrator').DS.'models'.DS.$child->attributes('name').'.php'))
						JFile::delete($this->installer->getPath('extension_administrator').DS.'models'.DS.$child->attributes('name').'.php');
				}
				else	{
					if ($this->removeFiles($child, 1) === false) {
						$retval = false;
					}				
				}
			}
		
		}
		
		/**
		 * ---------------------------------------------------------------------------------------------
		 * Custom Uninstallation Script Section
		 * ---------------------------------------------------------------------------------------------
		 */

		// Now lets load the uninstall file if there is one and execute the uninstall function if it exists.
		$uninstallfileElement =& $this->manifest->getElementByPath('uninstallfile');
		if (is_a($uninstallfileElement, 'JSimpleXMLElement')) {
			// Element exists, does the file exist?
			if (is_file($this->installer->getPath('extension_administrator').DS.'others'.DS.$uninstallfileElement->data())) {
				ob_start();
				ob_implicit_flush(false);
				require_once ($this->installer->getPath('extension_administrator').DS.'others'.DS.$uninstallfileElement->data());
				if (function_exists('com_uninstall')) {
					if (com_uninstall() === false) {
						$this->setError(JText::_('CUSTOMUNINSUNSU'));
						$retval = false;
					}
				}
				JFile::delete($this->installer->getPath('extension_administrator').DS.'others'.DS.$uninstallfileElement->data());
				$msg = ob_get_contents();
				ob_end_clean();
				if ($msg != '') {
					$this->installer->set('extension.message', $msg);
				}
			}
		}
		
		$this->removeMenus($views);
		
		return $retval;

	}
	
	function removeMenus($views)
	{
		
		$retval = true;
		
		foreach($views as $view)	{
			
			$query = 'delete from #__joomd_plugins where id = '.$view->id.' and iscore = 0';
			$this->_db->setQuery( $query );
			
			if(!$this->_db->query())
				$retval = false;
			
		}
		
		return $retval;
		
	}
	
	//check whether this a valid xml file
	
	function &_isManifest($file)
	{
		// Initialize variables
		$null	= null;
		$xml	=& JFactory::getXMLParser('Simple');

		// If we cannot load the xml file return null
		if (!$xml->loadFile($file)) {
			// Free up xml parser memory and return null
			unset ($xml);
			return $null;
		}

		/*
		 * Check for a valid XML root tag.
		 * @todo: Remove backwards compatability in a future version
		 * Should be 'install', but for backward compatability we will accept 'mosinstall'.
		 */
		$root =& $xml->document;
		if (!is_object($root) || ($root->name() != 'install')) {
			// Free up xml parser memory and return null
			unset ($xml);
			return $null;
		}

		// Valid manifest file return the object
		return $xml;
	}
	
	function removeFiles($element, $cid=0)
	{
		// Initialize variables
		$copyfiles = array ();
		
		// Get the client info
		jimport('joomla.application.helper');
		$client =& JApplicationHelper::getClientInfo($cid);

		if (!is_a($element, 'JSimpleXMLElement') || !count($element->children())) {
			// Either the tag does not exist or has no children therefore we return zero files processed.
			return 0;
		}

		// Get the array of file nodes to process
		$files = $element->children();
		if (count($files) == 0) {
			// No files to process
			return 0;
		}
		
		if ($client) {
			$pathname = 'extension_'.$client->name;
			$destination = $this->installer->getPath($pathname);
		} else {
			$pathname = 'extension_root';
			$destination = $this->installer->getPath($pathname);
		}
		
		switch($element->name())
		{
			
			case 'assets':
			$destination = $destination.DS.'assets';
			break;
			
			case 'classes':
			if($client)	{
				$destination = $destination.DS.'classes';
			} else	{
				$destination = $destination.DS.'others';
			}
			break;
			
			default:
			case 'others':
			$destination = $destination.DS.'others';
			break;
			
		}

		// Process each file in the $files array (children of $tagName).
		foreach ($files as $file)
		{
			
			if ($folder = $file->attributes('folder')) {
				$path['dest'] = $destination.DS.$folder.DS.$file->data();
			} else {
				$path['dest']	= $destination.DS.$file->data();
			}

			// Is this path a file or folder?
			if( $file->name() == 'folder')	{
			
				if(JFolder::exists($path['dest']))
					 JFolder::delete($path['dest']);
				
			}
			else	{
			
				if(JFile::exists($path['dest']))
					 JFile::delete($path['dest']);
			
			}
			
			array_push($copyfiles, $path);

		}

		return count($copyfiles);
	}
	
	/**
	 * Method to parse through a files element of the installation manifest and take appropriate
	 * action.
	 *
	 * @access	public
	 * @param	object	$element 	The xml node to process
	 * @param	int		$cid		Application ID of application to install to
	 * @return	boolean	True on success
	 * @since	1.5
	 */
	function parseViews($element, $cid=0)
	{
		// Initialize variables
		$copyfiles = array ();
		
		// Get the client info
		jimport('joomla.application.helper');
		$client =& JApplicationHelper::getClientInfo($cid);

		if (!is_a($element, 'JSimpleXMLElement') || !count($element->children())) {
			// Either the tag does not exist or has no children therefore we return zero files processed.
			return 0;
		}

		// Get the array of file nodes to process
		$files = $element->children();
		if (count($files) == 0) {
			// No files to process
			return 0;
		}

		/*
		 * Here we set the folder we are going to remove the files from.
		 */
		if ($client) {
			$pathname = 'extension_'.$client->name;
			$dest = $this->installer->getPath($pathname);
		} else {
			$pathname = 'extension_root';
			$dest = $this->installer->getPath($pathname);
		}
		
		$view = $element->attributes('name');
		
		$destination = $dest.DS.'views'.DS.$view;
		
		if(JFolder::exists($destination))	{
			$this->setError(sprintf(JText::_('VALREAEXIST'), $view));
			return false;
		}

		/*
		 * Here we set the folder we are going to copy the files from.
		 *
		 * Does the element have a folder attribute?
		 *
		 * If so this indicates that the files are in a subdirectory of the source
		 * folder and we should append the folder attribute to the source path when
		 * copying files.
		 */
		if ($folder = $element->attributes('folder')) {
			$source = $this->installer->getPath('source').DS.$folder;
		} else {
			$source = $this->installer->getPath('source');
		}

		// Process each file in the $files array (children of $tagName).
		foreach ($files as $file)
		{
			$path['src']	= $source.DS.$file->data();
			
			if($file->data() == 'model.php')
				$path['dest']	= $dest.DS.'models'.DS.$view.'.php';
			elseif($file->data() == 'controller.php')
				$path['dest']	= $dest.DS.'controllers'.DS.$view.'.php';
			elseif($file->data() == 'table.php' && $client->name == 'administrator')
				$path['dest']	= $dest.DS.'tables'.DS.$view.'.php';
			else
				$path['dest']	= $destination.DS.$file->data();

			// Is this path a file or folder?
			$path['type']	= ( $file->name() == 'folder') ? 'folder' : 'file';

			/*
			 * Before we can add a file to the copyfiles array we need to ensure
			 * that the folder we are copying our file to exits and if it doesn't,
			 * we need to create it.
			 */
			if (basename($path['dest']) != $path['dest']) {
				$newdir = dirname($path['dest']);

				if (!JFolder::create($newdir)) {
					$this->setError(JText::_('FTOCREDIR').' "'.$newdir.'"');
					return false;
				}
			}

			// Add the file to the copyfiles array
			$copyfiles[] = $path;
		}

		return $this->copyFiles($copyfiles);
	}
	
	function parseFiles($element, $cid=0)
	{
		// Initialize variables
		$copyfiles = array ();
		
		// Get the client info
		jimport('joomla.application.helper');
		$client =& JApplicationHelper::getClientInfo($cid);

		if (!is_a($element, 'JSimpleXMLElement') || !count($element->children())) {
			// Either the tag does not exist or has no children therefore we return zero files processed.
			return 0;
		}

		// Get the array of file nodes to process
		$files = $element->children();
		if (count($files) == 0) {
			// No files to process
			return 0;
		}
		
		if ($client) {
			$pathname = 'extension_'.$client->name;
			$destination = $this->installer->getPath($pathname);
		} else {
			$pathname = 'extension_root';
			$destination = $this->installer->getPath($pathname);
		}
		
		switch($element->name())
		{
			
			case 'assets':
			$destination = $destination.DS.'assets';
			break;
			
			case 'classes':
			if($client)	{
				$destination = $destination.DS.'classes';
			} else	{
				$destination = $destination.DS.'others';
			}
			break;
			
			default:
			case 'others':
			$destination = $destination.DS.'others';
			break;
			
		}

		/*
		 * Here we set the folder we are going to copy the files from.
		 *
		 * Does the element have a folder attribute?
		 *
		 * If so this indicates that the files are in a subdirectory of the source
		 * folder and we should append the folder attribute to the source path when
		 * copying files.
		 */
		if ($folder = $element->attributes('folder')) {
			$source = $this->installer->getPath('source').DS.$folder;
		} else {
			$source = $this->installer->getPath('source');
		}

		// Process each file in the $files array (children of $tagName).
		foreach ($files as $file)
		{
			$path['src']	= $source.DS.$file->data();
			
			if ($folder = $file->attributes('folder')) {
				$path['dest'] = $destination.DS.$folder.DS.$file->data();
			} else {
				$path['dest']	= $destination.DS.$file->data();
			}

			// Is this path a file or folder?
			$path['type']	= ( $file->name() == 'folder') ? 'folder' : 'file';

			/*
			 * Before we can add a file to the copyfiles array we need to ensure
			 * that the folder we are copying our file to exits and if it doesn't,
			 * we need to create it.
			 */
			if (basename($path['dest']) != $path['dest']) {
				$newdir = dirname($path['dest']);

				if (!JFolder::create($newdir)) {
					$this->setError(JText::_('FAILTCREDIR').' "'.$newdir.'"');
					return false;
				}
			}

			// Add the file to the copyfiles array
			$copyfiles[] = $path;
		}

		return $this->copyFiles($copyfiles);
	}
	
	/**
	 * Copy files from source directory to the target directory
	 *
	 * @access	public
	 * @param	array $files array with filenames
	 * @param	boolean $overwrite True if existing files can be replaced
	 * @return	boolean True on success
	 * @since	1.5
	 */
	function copyFiles($files, $overwrite=null)
	{
		/*
		 * To allow for manual override on the overwriting flag, we check to see if
		 * the $overwrite flag was set and is a boolean value.  If not, use the object
		 * allowOverwrite flag.
		 */
		if (is_null($overwrite) || !is_bool($overwrite)) {
			$overwrite = $this->installer->setOverwrite( true );
		}

		/*
		 * $files must be an array of filenames.  Verify that it is an array with
		 * at least one file to copy.
		 */
		if (is_array($files) && count($files) > 0)
		{
			foreach ($files as $file)
			{
				// Get the source and destination paths
				$filesource	= JPath::clean($file['src']);
				$filedest	= JPath::clean($file['dest']);
				$filetype	= array_key_exists('type', $file) ? $file['type'] : 'file';

				if (!file_exists($filesource)) {
					/*
					 * The source file does not exist.  Nothing to copy so set an error
					 * and return false.
					 */
					$this->setError($filesource.'::'.$filedest.JText::sprintf('FILEDNEXIS', $filesource));
					return false;
				} elseif (file_exists($filedest) && !$overwrite) {

						/*
						 * It's okay if the manifest already exists
						 */
						if ($this->installer->getPath( 'manifest' ) == $filesource) {
							continue;
						}

						/*
						 * The destination file already exists and the overwrite flag is false.
						 * Set an error and return false.
						 */
						$this->setError(JText::sprintf('WARNSAME', $filedest));
						return false;
				} else {

					// Copy the folder or file to the new location.
					if ( $filetype == 'folder') {

						if (!(JFolder::copy($filesource, $filedest, null, $overwrite))) {
							$this->setError('JInstaller::install: '.JText::sprintf('FAILEDTOCF', $filesource, $filedest));
							return false;
						}

						$step = array ('type' => 'folder', 'path' => $filedest);
					} else {

						if (!(JFile::copy($filesource, $filedest))) {
							$this->setError('JInstaller::install: '.JText::sprintf('FTOCFL', $filesource, $filedest));
							return false;
						}

						$step = array ('type' => 'file', 'path' => $filedest);
					}

					/*
					 * Since we copied a file/folder, we want to add it to the installation step stack so that
					 * in case we have to roll back the installation we can remove the files copied.
					 */
					$this->installer->pushStep( $step );
				}
			}
		} else {

			/*
			 * The $files variable was either not an array or an empty array
			 */
			$this->setError('Files not found.');
			return false;
		}
		return count($files);
	
	}
	
	
	/**
	 * Backward compatible Method to parse through a queries element of the
	 * installation manifest file and take appropriate action.
	 *
	 * @access	public
	 * @param	object	$element 	The xml node to process
	 * @return	mixed	Number of queries processed or False on error
	 * @since	1.5
	 */
	function parseQueries($element)
	{
		// Get the database connector object
		$db = & $this->_db;

		if (!is_a($element, 'JSimpleXMLElement') || !count($element->children())) {
			// Either the tag does not exist or has no children therefore we return zero files processed.
			return 0;
		}

		// Get the array of query nodes to process
		$queries = $element->children();
		if (count($queries) == 0) {
			// No queries to process
			return 0;
		}

		// Process each query in the $queries array (children of $tagName).
		foreach ($queries as $query)
		{
			$db->setQuery($query->data());
			if (!$db->query()) {
				$this->setError('JInstaller::install: '.JText::_('SQLERR')." ".$db->stderr(true));
				return false;
			}
		}
		return (int) count($queries);
	}

	/**
	 * Method to extract the name of a discreet installation sql file from the installation manifest file.
	 *
	 * @access	public
	 * @param	object	$element 	The xml node to process
	 * @param	string	$version	The database connector to use
	 * @return	mixed	Number of queries processed or False on error
	 * @since	1.5
	 */
	function parseSQLFiles($element)
	{
		// Initialize variables
		$queries = array();
		$db = & $this->_db;
		$dbDriver = strtolower($db->get('name'));
		if ($dbDriver == 'mysqli') {
			$dbDriver = 'mysql';
		}
		$dbCharset = ($db->hasUTF()) ? 'utf8' : '';

		if (!is_a($element, 'JSimpleXMLElement')) {
			// The tag does not exist.
			return 0;
		}

		// Get the array of file nodes to process
		$files = $element->children();
		if (count($files) == 0) {
			// No files to process
			return 0;
		}

		// Get the name of the sql file to process
		$sqlfile = '';
		foreach ($files as $file)
		{
			$fCharset = (strtolower($file->attributes('charset')) == 'utf8') ? 'utf8' : '';
			$fDriver  = strtolower($file->attributes('driver'));
			if ($fDriver == 'mysqli') {
				$fDriver = 'mysql';
			}

			if( $fCharset == $dbCharset && $fDriver == $dbDriver) {
				$sqlfile = $file->data();
				// Check that sql files exists before reading. Otherwise raise error for rollback
				if ( !file_exists( $this->installer->getPath('extension_administrator').DS.'others'.DS.$sqlfile ) ) {
					$this->setError(JText::_('SQLFDNEXIST'));
					return false;
				}
				$buffer = file_get_contents($this->installer->getPath('extension_administrator').DS.'others'.DS.$sqlfile);

				// Graceful exit and rollback if read not successful
				if ( $buffer === false ) {
					$this->setError(JText::_('CNREADSQFL'));
					return false;
				}

				// Create an array of queries from the sql file
				jimport('joomla.installer.helper');
				$queries = JInstallerHelper::splitSql($buffer);

				if (count($queries) == 0) {
					// No queries to process
					return 0;
				}

				// Process each query in the $queries array (split out of sql file).
				foreach ($queries as $query)
				{
					$query = trim($query);
					if ($query != '' && $query{0} != '#') {
						$db->setQuery($query);
						if (!$db->query()) {
							$this->setError('JInstaller::install: '.JText::_('SQLERR')." ".$db->stderr(true));
							return false;
						}
					}
				}
			}
		}

		return (int) count($queries);
	}
	
	/**
	 * Copies the installation manifest file to the extension folder in the given client
	 *
	 * @access	public
	 * @param	int		$cid	Where to copy the installfile [optional: defaults to 1 (admin)]
	 * @return	boolean	True on success, False on error
	 * @since	1.5
	 */
	function copyManifest($cid=1)
	{
		// Get the client info
		jimport('joomla.application.helper');
		$client =& JApplicationHelper::getClientInfo($cid);

		$path['src'] = $this->installer->getPath('manifest');

		if ($client) {
			$pathname = 'extension_'.$client->name;
		} else {
			$pathname = 'extension_root';
		}
		$path['dest']  = $this->installer->getPath($pathname).DS.'views'.DS.$this->installer->get('name').DS.basename($this->installer->getPath('manifest'));
		return $this->copyFiles(array ($path), true);
	}
	
	/**
	 * Method to parse through a languages element of the installation manifest and take appropriate
	 * action.
	 *
	 * @access	public
	 * @param	object	$element 	The xml node to process
	 * @param	int		$cid		Application ID of application to install to
	 * @return	boolean	True on success
	 * @since	1.5
	 */
	function parseLanguages($element, $cid=0)
	{
		// Initialize variables
		$copyfiles = array ();

		// Get the client info
		jimport('joomla.application.helper');
		$client =& JApplicationHelper::getClientInfo($cid);

		if (!is_a($element, 'JSimpleXMLElement') || !count($element->children())) {
			// Either the tag does not exist or has no children therefore we return zero files processed.
			return 0;
		}

		// Get the array of file nodes to process
		$files = $element->children();
		if (count($files) == 0) {
			// No files to process
			return 0;
		}

		/*
		 * Here we set the folder we are going to copy the files to.
		 *
		 * 'languages' Files are copied to JPATH_BASE/language/ folder
		 */
		$destination = $client->path.DS.'language';

		/*
		 * Here we set the folder we are going to copy the files from.
		 *
		 * Does the element have a folder attribute?
		 *
		 * If so this indicates that the files are in a subdirectory of the source
		 * folder and we should append the folder attribute to the source path when
		 * copying files.
		 */
		if ($folder = $element->attributes('folder')) {
			$source = $this->installer->getPath('source').DS.$folder;
		} else {
			$source = $this->installer->getPath('source');
		}

		// Process each file in the $files array (children of $tagName).
		foreach ($files as $file)
		{
			/*
			 * Language files go in a subfolder based on the language code, ie.
			 *
			 * 		<language tag="en-US">en-US.mycomponent.ini</language>
			 *
			 * would go in the en-US subdirectory of the language folder.
			 *
			 * We will only install language files where a core language pack
			 * already exists.
			 */
			if ($file->attributes('tag') != '') {
				$path['src']	= $source.DS.$file->data();
				$path['dest']	= $destination.DS.$file->attributes('tag').DS.basename($file->data());

				// If the language folder is not present, then the core pack hasn't been installed... ignore
				if (!JFolder::exists(dirname($path['dest']))) {
					continue;
				}
			} else {
				$path['src']	= $source.DS.$file->data();
				$path['dest']	= $destination.DS.$file->data();
			}

			/*
			 * Before we can add a file to the copyfiles array we need to ensure
			 * that the folder we are copying our file to exits and if it doesn't,
			 * we need to create it.
			 */
			if (basename($path['dest']) != $path['dest']) {
				$newdir = dirname($path['dest']);

				if (!JFolder::create($newdir)) {
					$this->setError(JText::_('FAILTCREDIR').' "'.$newdir.'"');
					return false;
				}
			}

			// Add the file to the copyfiles array
			$copyfiles[] = $path;
		}

		return $this->copyFiles($copyfiles);
	}
	
	/**
	 * Unpacks a file and verifies it as a Joomla element package
	 * Supports .gz .tar .tar.gz and .zip
	 *
	 * @static
	 * @param string $p_filename The uploaded package filename or install directory
	 * @return Array Two elements - extractdir and packagefile
	 * @since 1.5
	 */
	function unpack($p_filename)
	{
		// Path to the archive
		$archivename = $p_filename;

		// Temporary folder to extract the archive into
		$tmpdir = uniqid('install_');

		// Clean the paths to use for archive extraction
		$extractdir = JPath::clean(dirname($p_filename).DS.$tmpdir);
		$archivename = JPath::clean($archivename);

		// do the unpacking of the archive
		$result = JArchive::extract( $archivename, $extractdir);

		if ( $result === false ) {
			return false;
		}


		/*
		 * Lets set the extraction directory and package file in the result array so we can
		 * cleanup everything properly later on.
		 */
		$retval['extractdir'] = $extractdir;
		$retval['packagefile'] = $archivename;

		/*
		 * Try to find the correct install directory.  In case the package is inside a
		 * subdirectory detect this and set the install directory to the correct path.
		 *
		 * List all the items in the installation directory.  If there is only one, and
		 * it is a folder, then we will set that folder to be the installation folder.
		 */
		$dirList = array_merge(JFolder::files($extractdir, ''), JFolder::folders($extractdir, ''));

		if (count($dirList) == 1)
		{
			if (JFolder::exists($extractdir.DS.$dirList[0]))
			{
				$extractdir = JPath::clean($extractdir.DS.$dirList[0]);
			}
		}

		/*
		 * We have found the install directory so lets set it and then move on
		 * to detecting the extension type.
		 */
		$retval['dir'] = $extractdir;

		/*
		 * Get the extension type and return the directory/type array on success or
		 * false on fail.
		 */
		 
		if(version_compare(JVERSION, '1.6.0', 'lt'))
			$detectType = 'detectType15';
		else
			$detectType = 'detectType25';
		 
		if ($retval['type'] = $this->$detectType($extractdir))
		{
			return $retval;
		} else
		{
			return false;
		}
	}

	/**
	 * Method to detect the extension type from a package directory
	 *
	 * @static
	 * @param string $p_dir Path to package directory
	 * @return mixed Extension type string or boolean false on fail
	 * @since 1.5
	 */
	function detectType15($p_dir)
	{
		// Search the install dir for an xml file
		$files = JFolder::files($p_dir, '\.xml$', 1, true);

		if (count($files) > 0)
		{

			foreach ($files as $file)
			{
				$xmlDoc = & JFactory::getXMLParser();
				$xmlDoc->resolveErrors(true);

				if (!$xmlDoc->loadXML($file, false, true))
				{
					// Free up memory from DOMIT parser
					unset ($xmlDoc);
					continue;
				}
				$root = & $xmlDoc->documentElement;
				if (!is_object($root) || ($root->getTagName() != "install" && $root->getTagName() != 'mosinstall'))
				{
					unset($xmlDoc);
					continue;
				}

				$type = $root->getAttribute('type');
				// Free up memory from DOMIT parser
				unset ($xmlDoc);
				return $type;
			}

			$this->setError(JText::_('ERRORNOTFINDXMLSETUPFILE'));
			// Free up memory from DOMIT parser
			unset ($xmlDoc);
			return false;
		} else
		{
			$this->setError(JText::_('ERRORNOTFINDXMLSETUPFILE'));
			return false;
		}
	}
	
	/**
	 * Method to detect the extension type from a package directory
	 *
	 * @param   string  $p_dir  Path to package directory
	 *
	 * @return  mixed  Extension type string or boolean false on fail
	 *
	 * @since   1.6
	 */
	public static function detectType25($p_dir)
	{
		// Search the install dir for an XML file
		$files = JFolder::files($p_dir, '\.xml$', 1, true);

		if (!count($files))
		{
			$this->setError(JText::_('ERRORNOTFINDXMLSETUPFILE'));
			return false;
		}

		foreach ($files as $file)
		{
			if (!$xml = JFactory::getXML($file))
			{
				continue;
			}

			if ($xml->getName() != 'install' && $xml->getName() != 'extension')
			{
				unset($xml);
				continue;
			}

			$type = (string) $xml->attributes()->type;
			// Free up memory
			unset($xml);
			return $type;
		}

		$this->setError(JText::_('ERRORNOTFINDXMLSETUPFILE'));
		// Free up memory.
		unset($xml);
		return false;
	}
	
}

?>