<?php 
/**
 * Joomla! component SimpleLists
 *
 * @author Yireo
 * @package SimpleLists
 * @copyright Copyright (C) 2011
 * @license GNU Public License
 * @link http://www.yireo.com/
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

// Set the right image directory for JavaScipt
jimport('joomla.utilities.utility');
$js_image_directory = str_replace( DS, '/', $this->item->image_directory );
?>

<script language="javascript" type="text/javascript">
    <!--
    var image_directory = '<?php echo $js_image_directory; ?>';
    var form_no_title = '<?php echo JText::_( 'Empty title', true ); ?>' ;
    -->
</script>

<form method="post" name="adminForm" id="adminForm">
<table cellspacing="0" cellpadding="0" border="0" width="100%">
<tbody>
<tr>
<td width="50%" valign="top">
    <fieldset class="adminform">
        <legend><?php echo JText::_( 'Details' ); ?></legend>
        <table class="admintable">
        <tbody>
        <tr>
            <td width="100" align="right" class="key">
                <label for="title">
                    <?php echo JText::_( 'Name' ); ?>:
                </label>
            </td>
            <td class="value">
                <input class="text_area" type="text" name="title" id="title" size="48" maxlength="250" value="<?php echo $this->item->title; ?>" />
            </td>
        </tr>
        <tr>
            <td width="100" align="right" class="key">
                <label for="alias">
                    <?php echo JText::_( 'Alias' ); ?>:
                </label>
            </td>
            <td class="value">
                <input class="text_area" type="text" name="alias" id="alias" size="48" maxlength="250" value="<?php echo $this->item->alias;?>" />
            </td>
        </tr>
        <tr>
            <td valign="top" align="right" class="key">
                <?php echo JText::_( 'Published' ); ?>:
            </td>
            <td class="value">
                <?php echo $this->lists['published']; ?>
            </td>
        </tr>
        <tr>
            <td valign="top" align="right" class="key">
                <label for="categories">
                    <?php echo JText::_( 'Categories' ); ?>:
                </label>
            </td>
            <td class="value">
                <?php echo $this->lists['categories']; ?>
            </td>
        </tr>
        <tr>
            <td valign="top" align="right" class="key">
                <label for="ordering">
                    <?php echo JText::_( 'Ordering' ); ?>:
                </label>
            </td>
            <td class="value">
                <?php echo $this->lists['ordering']; ?>
            </td>
        </tr>
        <tr>
            <td valign="top" class="key">
                <label for="access">
                    <?php echo JText::_( 'Access Level' ); ?>:
                </label>
            </td>
            <td class="value">
                <?php echo $this->lists['access']; ?>
            </td>
        </tr>
        </tbody>
    </table>
    </fieldset>
    <fieldset class="adminform">
        <legend><?php echo JText::_( 'Text' ); ?></legend>
        <table class="admintable" width="100%">
        <tbody>
        <tr>
            <td class="value">
                <?php
                $editor =& JFactory::getEditor();
                echo $editor->display( 'text', $this->item->text, '100%', '300', '44', '9', array('pagebreak', 'readmore' )) ;
                ?>
            </td>
        </tr>
        </tbody>
        </table>
    </fieldset>
</td>
<td width="50%" valign="top">
    <?php echo $this->pane->startPane('content-pane'); ?>
    <?php echo $this->pane->startPanel('Image', 'image'); ?>
    <table class="admintable">
    <tbody>
        <tr>
            <td>
                <input type="text" id="picture_name" value="<?php echo $this->item->picture; ?>" disabled="disabled" />
                <input type="hidden" id="picture" name="picture" value="<?php echo $this->item->picture; ?>" />
            </td>
            <td>
                <div class="button2-left">
                    <div class="blank">
                        <a class="modal-button" title="<?php echo JText::_('Select an Image') ?>" href="<?php echo $this->modal['picture']; 
                        ?>" rel="{handler: 'iframe', size: {x: 770, y: 500}}">
                        <?php echo JText::_('Select an Image'); ?>
                        </a>
                    </div>
                </div>
            </td>
        </tr>
        <tr>
            <td colspan="2">
                <?php 
                if( JFile::exists( JPATH_SITE.DS.$this->item->image_directory.DS.$this->item->picture )) {
                    echo '<img src="../' . $this->item->image_directory . '/' . $this->item->picture . '" name="item_picture" />' ;
                } else {
                    echo '<img src="../media/com_simplelists/images/blank.png" alt="' . JText::_( 'No image' ) . '" name="item_picture" width="1" height="1" />' ;
                } ?>
            </td>
        </tr>
    </tbody>
    </table>
    <?php echo $this->pane->endPanel(); ?>
    <?php echo $this->pane->startPanel('Link Settings', 'link'); ?>
    <?php if(!empty($this->link_plugins)) { ?>
    <table class="paramlist admintable" width="100%">
    <tbody>
        <?php foreach($this->link_plugins as $plugin) { ?>
            <?php if($plugin->isEnabled() == false) continue; ?>
            <?php $link_type = $plugin->getPluginName(); ?>
            <?php $active = ($link_type == $this->item->link_type) ? true : false; ?>
            <tr>
                <td valign="top" align="right" class="key">
                    <?php $checked = ($active) ? 'checked="checked"' : '' ; ?>
                    <input type="radio" class="simplelists_link" id="link_type_<?php echo $link_type; ?>" name="link_type" value="<?php echo $link_type; ?>" <?php echo $checked; ?> />
                </td>
                <td>
                    <?php $classes = array('simplelists_link_inner', 'simplelists_link_inner_type_'.$link_type); ?>
                    <?php if($active) $classes[] = 'simplelists_link_inner_active'; ?>
                    <div class="<?php echo implode(' ', $classes); ?>" id="simplelists_link_inner<?php echo $link_type; ?>">
                    <label class="simplelists_link" for="link_type_<?php echo $link_type; ?>" id="link_type_<?php echo $link_type; ?>_label">
                        <?php echo $plugin->getTitle(); ?>
                    </label>
                    <?php $current = ($link_type == $this->item->link_type) ? $this->item->link : null; ?>
                    <?php echo $plugin->getInput($current); ?>
                    </div>
                </td>
            </tr>
        <?php } ?>
    </tbody>
    </table>
    <?php } else { ?>
        <p style="padding:10px;"><?php echo JText::_('You have not published any SimpleListsLink plugins'); ?></p>
    <?php } ?>
    <?php echo $this->pane->endPanel(); ?>
    <?php if(YireoHelper::isJoomla15()) { ?>
        <?php echo $this->pane->startPanel('Parameters', 'params'); ?>
        <table class="paramlist admintable" cellspacing="1">
        <tbody>
            <tr>
                <td colspan="2" class="params">
                    <?php echo $this->params->render();?>
                </td>
            </tr>
        </tbody>
        </table>
        <?php echo $this->pane->endPanel(); ?>
    <?php } elseif($this->form) { ?>
        <?php foreach($this->form->getFieldsets() as $fieldset) { ?>
            <?php echo $this->pane->startPanel(JText::_($fieldset->label), $fieldset->name); ?>
            <table class="paramlist admintable" cellspacing="1">
                <tbody>
                <tr>
                     <td colspan="2" class="params">
                        <?php foreach($this->form->getFieldset($fieldset->name) as $field) { ?>
                        <dl>
                            <dt><?php echo $field->label; ?></dt>
                            <dd><?php echo $field->input; ?></dd>
                        <dl>
                        <?php } ?>
                    </td>
                </tr>
                </tbody>
            </table>
            <?php echo $this->pane->endPanel(); ?>
        <?php } ?>
    <?php } ?>
    <?php echo $this->pane->endPane(); ?>
</td>
</tr>
</tbody>
</table>

<input type="hidden" name="option" value="com_simplelists" />
<input type="hidden" name="cid[]" value="<?php echo $this->item->id; ?>" />
<input type="hidden" name="task" value="" />
<?php echo JHTML::_( 'form.token' ); ?>
</form>
