<?php
/**
 * Joomla! component SimpleLists
 *
 * @author Yireo
 * @package SimpleLists
 * @copyright Copyright (C) 2011
 * @license GNU Public License
 * @link http://www.yireo.com/
 */

// Check to ensure this file is included in Joomla! 
defined('_JEXEC') or die();

// Require the parent view
require_once JPATH_COMPONENT.DS.'lib'.DS.'view.php';

// Import the needed helpers
require_once JPATH_COMPONENT.DS.'helpers'.DS.'html.php';

/**
 * HTML View class for the Simplelists component
 *
 * @static
 * @package    Simplelists
 */
class SimplelistsViewItem extends YireoView
{
    /*
     * Method to prepare the content for display
     *
     * @param string $tpl
     * @return null
     */
    public function display($tpl = null)
    {
        // Give a warning if no categories are configured
        SimplelistsHelper::checkCategories() ;

        // Fetch the item automatically
        $this->fetchItem(true);
    
        // Modify the item a bit
        $this->item->image_directory = COM_SIMPLELISTS_DIR ;

        // Add extra filtering lists
        $categories_params = array('item_id' => $this->item->id, 'multiple' => 1);
        $this->lists['categories'] = SimplelistsHTML::selectCategories( 'categories[]', $categories_params );
 
        // Construct the modal boxes
        $modal = array() ;
        $modal['picture'] = 'index.php?option=com_simplelists&amp;view=files&amp;tmpl=component&amp;type=picture&amp;current='.$this->item->picture;
        if($this->item->picture) {
            $modal['picture'] .= '&amp;folder=/'.dirname($this->item->picture);
        }
        $this->assignRef('modal', $modal);

        // Construct the slider-panel
        jimport('joomla.html.pane');
        $pane = & JPane::getInstance('sliders');
        $this->assignRef('pane', $pane);

        // Include extra JavaScript
        $this->addJs('mootools-cookie.js');
        $this->addJs('view-browser.js');

        // Load the plugins
        $link_plugins = SimplelistsPluginHelper::getPlugins('simplelistslink');
        $this->assignRef('link_plugins', $link_plugins);

        // Add extra stuff
        JHTML::_('behavior.tooltip');
        JHTML::_('behavior.modal', 'a.modal-button');

        parent::display($tpl);
    }
}
