<?php

/*------------------------------------------------------------------------
# com_joomd - Joomd Manager
# ------------------------------------------------------------------------
# author    Danish Babu - Joomla6Teen Inc
# copyright Copyright (C) 2011 joomla6teen.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.joomla6teen.com
# Technical Support:  Forum - http://www.joomla6teen.com/index.php?option=com_ccboard&view=forumlist&Itemid=63
-----------------------------------------------------------------------*/

// No direct access
 
defined( '_JEXEC' ) or die( 'Restricted access' );
 
jimport( 'joomla.application.component.model' );
 
class JoomdModelEntrypanel extends JModel
{
	
	var $_notice=null;
	
	function __construct()
	{
		parent::__construct();
		
		$mainframe =& JFactory::getApplication();
		
		$context = 'com_joomd.entrypanel.list.'; 
 
        $this->config = Joomd::getConfig('entry');
		$this->_user = Joomd::getUser('entry');
		$this->_field = new JoomdFields('entry');
		
		// Get pagination request variables
		$this->limit = JRequest::getInt('limit', $mainframe->getCfg('list_limit'));
		$this->limitstart = JRequest::getInt('limitstart', 0 );
 
        // In case limit has been changed, adjust it
        $this->limitstart = ($this->limit != 0 ? (floor($this->limitstart / $this->limit) * $this->limit) : 0);
		
		$this->_typeid = $mainframe->getUserStateFromRequest( $context.'typeid', 'typeid', 1,	'int' );
		
		$this->filter_cat		= $mainframe->getUserStateFromRequest( $context.'filter_cat',	'filter_cat',	0,	'int' );
		$this->filter_state		= $mainframe->getUserStateFromRequest( $context.'filter_state',	'filter_state',	'',	'word' );
		$this->filter_order	= $mainframe->getUserStateFromRequest( $context.'filter_order', 'filter_order', 'i.ordering', 'cmd' );
        $this->filter_order_Dir = $mainframe->getUserStateFromRequest( $context.'filter_order_Dir', 'filter_order_Dir', 'asc', 'word' );
		$this->filter_search = $mainframe->getUserStateFromRequest( $context.'filter_search', 'filter_search', '',	'string' );
		$this->filter_search = JString::strtolower( $this->filter_search );
				
		$this->Itemid = JRequest::getVar('Itemid', '');
		
		$array = JRequest::getVar('cid',  0, '', 'array');
		$this->setId((int)$array[0]);
		
	}
	
	//to display the notice if it's ajax
	function getNotice()
	{
		
		return $this->_notice;
		
	}
	
	function setNotice($msg=null)
	{
		
		$this->_notice = $msg;
		
	}
	//to display the notice if it's ajax
	
	function setId($id)
	{
		// Set id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}
	
	function _buildQuery()
	{
		
		$query = 'SELECT i.* from #__joomd_entry as i ';
		
		return $query;
	}
	
	function &getItem()
    {
		
		JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_joomd'.DS.'tables');
		$row =& JTable::getInstance('entry', 'Table');
		
		$item = $row->loadentry($this->_id);
		
		if($item->id and $item->created_by <> $this->_user->id)
			Joomd::redirect(JRoute::_('index.php?option=com_joomd&view=entrypanel&typeid='.$this->_typeid), JText::_('AUTH_NOACCESS'));
		
        return $item;
    }
	
	function &getItems()
    {
        if(empty($this->_data))	{
		
			$query = $this->_buildQuery();
			$filter = $this->_buildItemFilter();
			$query .= $filter;
			$orderby = $this->_buildItemOrderBy();
			$query .= $orderby;
			
			$this->_data = $this->_getList($query, $this->limitstart, $this->limit);
		}

        return $this->_data;
    }
	
	function _buildItemFilter()
	{
       
	    $where = array();
		
		$where[] = 'typeid = '.$this->_typeid;
		
		$where[] = ' i.created_by = '.(int)$this->_user->id;
				
		if ( $this->filter_state == 'P' )
			$where[] = 'i.published = 1';
		
		else if ($this->filter_state == 'U' )
			$where[] = 'i.published = 0';
		
		if ($this->filter_cat)	{
			
			$query = 'select itemid from #__joomd_entry_cat where catid = '.$this->filter_cat;
			$this->_db->setQuery( $query );
			$ids = $this->_db->loadResultArray();
			
			$in = count($ids)?implode(',', $ids):'0';
			
			$where[] = ' i.id in ( '.$in.' )';
			
		}

		if($this->filter_search)	{
			
			$where2 = array();
			
			$corefields = $this->_field->getCoreFields();
			
			for($i=0;$i<count($corefields);$i++)
				$where2[] = 'LOWER( i.field_'.$corefields[$i]->id.' ) LIKE '.$this->_db->Quote( '%'.$this->_db->getEscaped( $this->filter_search, true ).'%', false );
			
			$query = 'select itemid from #__joomd_entry_fielddata where LOWER( value ) LIKE '.$this->_db->Quote( '%'.$this->_db->getEscaped( $this->filter_search, true ).'%', false );
			$this->_db->setQuery( $query );
			$entries = (array)$this->_db->loadResultArray();
			
			if(count($entries))
				$where2[] = 'i.id in ('.implode(', ', $entries).')';
			
			$where[] = count($where2)?'( '.implode(' or ', $where2).' )':'i.id=0';
		}
		
		$filter = count($where) ? ' where ' . implode(' and ', $where) : '';		

        return $filter;
	}
	
	function _buildItemOrderBy()
	{
 
        $orderby = ' group by i.id order by '.$this->filter_order.' '.$this->filter_order_Dir;
 
        return $orderby;
		
	}
	
	function getParams()
  	{	
		
		$layout = JRequest::getCmd('layout', 'default');
		
		$item->option		= 'com_joomd';
		$item->view			= 'entrypanel';
		$item->abase		= 1;
		$item->task			= '';
		$item->Itemid		= $this->Itemid;
		$item->typeid 		= $this->_typeid;
		
		if($layout == 'default')	{
			
			$item->boxchecked	= 0;
			$item->limit		= $this->limit;
			$item->limitstart	= $this->limitstart;
			$item->filter_cat	= $this->filter_cat;
			$item->filter_search= $this->filter_search;
			$item->filter_state = $this->filter_state;
			$item->filter_order = $this->filter_order;
			$item->filter_order_Dir = $this->filter_order_Dir;
			
			// Load the plugin if it doesn't already exist
			if (empty($this->_total)) {
				$query = $this->_buildQuery();
				$filter = $this->_buildItemFilter();
				$query .= $filter;
				$orderby = $this->_buildItemOrderBy();
				$query .= $orderby;
				$item->total = (int) $this->_getListCount($query);
			}
		
		}
		else
			$item->id = $this->_id;
		
        return $item;
  	}
	
	function getCats()
    {
		
		$where = '';
				
		$query = 'select catid from #__joomd_tnc where typeid = '.$this->_typeid;
		$this->_db->setQuery( $query );
		$cats = (array)$this->_db->loadResultArray();
		
		$where = count($cats)?('where id in ('.implode(', ', $cats).')'):' where id = 0';
		
		$query = 'select *, name as title, parent as parent_id, false as selected from #__joomd_category '.$where.' order by name asc';
		
		$this->_db->setQuery($query);
		$rows = (array)$this->_db->loadObjectList();
		
		if(!count($rows))
			return array();
		
		if($this->_id)	{
		
			$query = 'select catid from #__joomd_entry_cat where itemid = ' . $this->_id;
			$this->_db->setQuery( $query );
			$cats = (array)$this->_db->loadResultArray();
			
			for($i=0;$i<count($rows);$i++)	{
			
				if(in_array($rows[$i]->id, $cats))
					$rows[$i]->selected = true;
				else
					$rows[$i]->selected = false;
			
			}
		
		}
			
		$children = array();
		// first pass - collect children
			
		foreach ($rows as $v )
		{
			$pt = $v->parent;
			$list = @$children[$pt] ? $children[$pt] : array();
			array_push( $list, $v );
			$children[$pt] = $list;
		}
			
		$list = JHTML::_('menu.treerecurse', 0, '', array(), $children, max( 0, 10 ) );
		
		$data = array_slice($list, 0);
		
        return $data;
    }
	
	function store()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( JText::_('INVALIDTOKEN') );
		
		$post = JRequest::get('post');
		$post['cats'] = JRequest::getVar('catid', array(), 'post', 'array');
		
		JArrayHelper::toInteger( $post['cats'] );
		
		$post['published'] = $this->config->approve;
		
		JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_joomd'.DS.'tables');
		$row =& JTable::getInstance('entry', 'Table');
		
		$row->load(JRequest::getInt('id', 0));
		
		$obj->result = 'error';
		$obj->file = array();
		
		if($this->config->captcha and class_exists('plgSystemJoomdcaptcha'))	{
		
			$captchk = plgSystemJoomdcaptcha::check($post['captcha']);
		
			if ($captchk !== true)	{
      			$obj->error = JText::_('THECONCDUENTINC');
				return $obj;
			}
		}
		
		if($this->config->registration && $this->_user->get('guest'))	{
			$obj->error = JText::_('UNEEDTOLOGADDE');
			return $obj;
		}
		
		if($post['id'] && $this->_user->id <> $row->created_by)	{
			$obj->error = JText::_('UNAUTHORIZEACC');
			return $obj;
		}
		
		if(!$row->bind($post))	{
			$obj->error = $row->getError();
			return $obj;
		}
		
		$obj = $row->check($post);
		
		if($obj->result == 'error')	{
			return $obj;
		}
		
		$obj->result = 'error';
		
		// If there was an error with registration, set the message and display form
		if(!$row->storeentry($post))	{
			$obj->error = $row->getError();
			return $obj;
		}
		
		$obj->id = $row->id;
		$obj->alias = $row->alias;
		
		
		if(!$post['id'])	{
			
			foreach((array)$obj->file as $file)	{
				
				if(isset($file->delete_url))	{
					
					$file->delete_url = str_replace('delete_custom&id=', 'delete_custom&id='.$obj->id, $file->delete_url);
					
				}
				
			}
			
		}
		
		$query = 'delete from #__joomd_entry_cat where itemid = '.$row->id;
		$this->_db->setQuery( $query );
		
		if(!$this->_db->query())	{
			$obj->error = $this->_db->getErrorMsg();
			return $obj;
		}
		
		foreach($post['cats'] as $cat)	{
		
			$query = 'insert into #__joomd_entry_cat values('.$cat.', '.$row->id.')';
			$this->_db->setQuery( $query );
			
			if(!$this->_db->query())	{
				$obj->error = $this->_db->getErrorMsg();
				return $obj;
			}
			
		}
		
		$obj->result = 'success';
		$obj->msg = JText::_('ENTRYSVSUCC');
		
		return $obj;
		
	}
	
	function delete()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$cid 			= JRequest::getVar( 'cid', array(), '', 'array' );

		JArrayHelper::toInteger( $cid );
		

		if (count( $cid ) < 1) {
			$this->setError( JText::_( 'SELENTTODEL', true ) );
			return false;
		}
		
		JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_joomd'.DS.'tables');
		$row =& JTable::getInstance('entry', 'Table');

		foreach ($cid as $id)
		{
			
			if(!$row->delete($id))	{
				$this->setError($row->getError());
				return false;
				
			}

		}

		return true;
	}
	
	function delete_custom()
	{
		
		$id = JRequest::getInt('id', 0);
		$fieldid = JRequest::getInt('fieldid', 0);
		$filename = JRequest::getVar('filename', null);
		
		if(!$id or !$fieldid)	{
			$this->setError(JText::_('PLSSELFTODEL'));
			return false;
		}
		
		$val = $this->_field->getfieldvalue($id, $fieldid);
		
		if(!empty($val))	{
			
			$values = explode('|', str_replace(' ', '', $val));
			
			for($i=0;$i<count($values);$i++)	{
				$value = $values[$i];
				
				if(empty($filename))	{
				
					if(is_file(JPATH_SITE.'/images/joomd/'.$value))
						unlink(JPATH_SITE.'/images/joomd/'.$value);
						
					if(is_file(JPATH_SITE.'/images/joomd/thumbs/'.$value))
						unlink(JPATH_SITE.'/images/joomd/thumbs/'.$value);
						
					unset($values[$i]);
					
				}
				elseif($filename == $value)	{
					if(is_file(JPATH_SITE.'/images/joomd/'.$value))
						unlink(JPATH_SITE.'/images/joomd/'.$value);
					
					if(is_file(JPATH_SITE.'/images/joomd/thumbs/'.$value))
						unlink(JPATH_SITE.'/images/joomd/thumbs/'.$value);
						
					unset($values[$i]);	
					
					break;
				}
				
			}
			
			$val = implode('|', $values);
			
		}
		
		if(!$this->_field->updatefieldvalue($id, $fieldid, $val))	{
			$this->setError($this->_field->getError());
			return false;
		}
		
		return true;
		
	}
	
}
