<?php

/*------------------------------------------------------------------------
# com_joomd - JoomD
# ------------------------------------------------------------------------
# author    Danish Babu - Joomla6Teen Inc
# copyright Copyright (C) 2011 joomla6teen.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.joomla6teen.com
# Technical Support:  Forum - http://www.joomla6teen.com/index.php?option=com_ccboard&view=forumlist&Itemid=63
-----------------------------------------------------------------------*/

/**
 * @param	array	A named array
 * @return	array
 */
function JoomdBuildRoute( &$query )
{
	$db =& JFactory::getDBO();
	$segments = array();
	
	$menu = &JSite::getMenu();
	if (empty($query['Itemid'])) {
		$menuItem = &$menu->getActive();
	} else {
		$menuItem = &$menu->getItem($query['Itemid']);
	}
	
	if(!isset($query['view']))
		unset($query['typeid']);
	
	if(isset($query['typeid']))	{
		$typeid = (int)$query['typeid'];
		unset($query['typeid']);
	}
	else
		$typeid = 1;
	
	if(isset($query['view']))	{
		
		$q = 'select alias from #__joomd_types where id = '.$typeid;
		$db->setQuery( $q );
		$segments[] = $db->loadResult();
		
		switch($query['view'])	{
		
			case 'category':
				$segments[] = 'categories';
								
				if(isset($query['catid']))	{
					$q = 'select alias from #__joomd_category where id = '.(int)$query['catid'];
					$db->setQuery( $q );
					$alias = $db->loadResult();
					
					$segments[] = empty($alias)?$query['catid']:$alias;
					
					unset($query['catid']);
				}
				
			break;
			
			case 'entry':
				
				$segments[] = 'items';
								
				if(isset($query['catid']))	{
					$q = 'select alias from #__joomd_category where id = '.(int)$query['catid'];
					$db->setQuery( $q );
					$alias = $db->loadResult();
					
					$segments[] = empty($alias)?$query['catid']:$alias;
					
					unset($query['catid']);
				}
				
				if(isset($query['layout']))	{
					$segments[] = 'view';
					
					if(isset($query['id']))	{
						$q = 'select alias from #__joomd_entry where id = '.(int)$query['id'];
						$db->setQuery( $q );
						$alias = $db->loadResult();
						
						$segments[] = empty($alias)?$query['id']:$alias;
						
						unset($query['id']);
					}
					unset($query['layout']);
				}
				
			break;
		
			case 'entrypanel' :
				
				$segments[] = 'your-items';
								
				if(isset($query['layout']))	{
					
					if(isset($query['cid']) and $query['cid'][0]>0)	{
						$segments[] = 'edit';
						$q = 'select alias from #__joomd_entry where id = '.(int)$query['cid'][0];
						$db->setQuery( $q );
						$alias = $db->loadResult();
						
						$segments[] = empty($alias)?$query['cid'][0]:$alias;
						
						unset($query['cid']);
					}
					elseif(isset($query['cid']))	{
						$segments[] = 'new';
						unset($query['cid']);
					}
					else	
						$segments[] = 'new';
						
					unset($query['layout']);
				}
				
			break;
			
			case 'search':
			
				if(isset($query['layout']) and $query['layout'] == "search")	{
					$segments[] = 'search-results';
					unset($query['layout']);
				}
				else
					$segments[] = 'search';
			
			break;
		
		}
		
		unset($query['view']);
	}
	
	return $segments;
}

/**
 * @param	array	A named array
 * @param	array
 *
 * Formats:
 *
 * index.php?/banners/task/bid/Itemid
 *
 * index.php?/banners/bid/Itemid
 */
function JoomdParseRoute( $segments )
{	
	$db =& JFactory::getDBO();
	$vars = array();

	// view is always the first element of the array
	$count = count($segments);
	
	
	$q = 'select id from #__joomd_types where alias = '.$db->Quote(str_replace(':', '-', $segments[0]));
	$db->setQuery( $q );
	$id = $db->loadResult();
	
	$vars['typeid'] = empty($id)?$segments[0]:$id;
	
	$count--;
	array_shift( $segments );
	
	if ($count)
	{
		
		$segments[0] = str_replace(':', '-', $segments[0]);
		
		switch($segments[0])	{
			
			case 'categories':
				$vars['view'] = 'category';
				$count--;
				array_shift( $segments );
				
				if($count)	{	
					$q = 'select id from #__joomd_category where alias = '.$db->Quote(str_replace(':', '-', $segments[0]));
					$db->setQuery( $q );
					$id = $db->loadResult();
					
					$vars['catid'] = empty($id)?$segments[0]:$id;
									
					$count--;
					array_shift( $segments );
				}
				
			break;
			
			case 'items':
			
				$vars['view'] = 'entry';
				
				$count--;
				array_shift( $segments );
				
				if($count)	{
				
					if($segments[0] == 'view')	{
						$vars['layout'] = 'detail';
						$count--;
						array_shift( $segments );
						
						if($count)	{
							$q = 'select id from #__joomd_entry where alias = '.$db->Quote(str_replace(':', '-', $segments[0]));
							$db->setQuery( $q );
							$id = $db->loadResult();
							
							$vars['id'] = empty($id)?$segments[0]:$id;
							
							$count--;
							array_shift( $segments );
						}
						
					}
					
					else	{
						$q = 'select id from #__joomd_category where alias = '.$db->Quote(str_replace(':', '-', $segments[0]));
						$db->setQuery( $q );
						$id = $db->loadResult();
						
						$vars['catid'] = empty($id)?$segments[0]:$id;
						
						$count--;
						array_shift( $segments );
					}
				
				}
				
			break;
			
			case 'your-items':
				
				$vars['view'] = 'entrypanel';
				
				$count--;
				array_shift( $segments );
				
				if($count)	{
				
					$vars['layout'] = 'form';
					
					$count--;
					array_shift( $segments );
					
					if($count)	{
						$q = 'select id from #__joomd_entry where alias = '.$db->Quote(str_replace(':', '-', $segments[0]));
						$db->setQuery( $q );
						$id = $db->loadResult();
						
						$vars['cid'][] = empty($id)?$segments[0]:$id;
						
						$count--;
						array_shift( $segments );
					}
				
				}
			
			break;
			
			case 'search-results':
				
				$vars['view'] = 'search';
				$vars['layout'] = 'search';
				
				$count--;
				array_shift( $segments );
					
				$count--;
				array_shift( $segments );
				
			break;
			
			case 'search':
				
				$vars['view'] = 'search';
				
				$count--;
				array_shift( $segments );
				
			break;
			
		}
		
	}

	return $vars;
}